; This utility prints out the full file name of all files in the current folder
;   and all sub folders.  This is a console application.
; This utility prints out the full file name of all files in the current folder and all
;   sub folders. It changes folder and uses recursion. This is a console application.
.nolist
include \masm32\include\masm32rt.inc
.listall
.data
Pattern db "*.*",0
Parent db "..",0
fcount dd 0
.data?
count db 10 dup (?)
wfd WIN32_FIND_DATA <?>  ; for FindFIrstFile/FindNextFile
.code
inv equ invoke
Program:
    call FindAllFiles  ;main
    inv dwtoa,fcount,addr count
    print addr count
    print " total files",13,10
    inv ExitProcess, 0

FindAllFiles proc	; assumes FileN contains full path to folder wanted,
                    ;   pFile points to zero byte terminator
    LOCAL SearchHandle :dword
    LOCAL CurrFolder[260]:byte

	inv GetCurrentDirectory,260,addr CurrFolder	; for printing
    inv FindFirstFile,offset Pattern,ADDR wfd
    mov SearchHandle,eax
    cmp eax,INVALID_HANDLE_VALUE
    je	continue	; out of files, go move up or quit
	jmp @f		; already have one, skip over findnext

iloop:
	inv FindNextFile, SearchHandle,ADDR wfd
    or 	eax,eax
    jz 	CloseSearchHandle
@@:
    mov eax,offset wfd.cFileName
    cmp byte ptr [eax],'.'	; discard current and parent directory
    je 	iloop
    test wfd.dwFileAttributes,FILE_ATTRIBUTE_DIRECTORY	; was it a new folder?
    jz 	PrintFileName		; go print file name
  	inv SetCurrentDirectory,ADDR wfd.cFileName
  	or eax,eax
  	jz	@f				; no good, just continue with current folder
   	call FindAllFiles 	; recurse to next directory level
@@:
	jmp iloop
	
PrintFileName:    
   	print addr CurrFolder,"\"
   	print ADDR wfd.cFileName,13,10
   	inc fcount
   	jmp iloop
    
CloseSearchHandle:
	inv FindClose,SearchHandle	; done with this search handle, close it

continue:
	inv SetCurrentDirectory,addr Parent  ; move up a folder
    ret

FindAllFiles endp

end Program





















